package revisionesServlet;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import m05bClasses.m05bComun;
import m05bClasses.m05bConexion;
import m05bClasses.m05bConstantes;
import m05bClasses.m05bConstantesInformes;
import m05bClasses.m05bFileLog;

import org.apache.fop.apps.Driver;
import org.apache.fop.apps.FOPException;
import org.xml.sax.InputSource;


public class m05bImpVencidasItvsServlet extends javax.servlet.http.HttpServlet
{
		java.sql.Connection conn=null;
		String sLinea;
        String sFoFileDir = "/datos/m05b/tmp/";
        File foFileDir ;
        File tmpFoFile ;
		FileOutputStream tmpFoFileStream ;
	    m05bComun miComun = new m05bComun();
		m05bFileLog miLog = new m05bFileLog();
		String sFecDesde="";
		String sFecHasta="";
		String sSituacion="";
		String sDesDpto="";
	
   public static final String FO_REQUEST_PARAM = "fo";
//    Logger log = null;

   public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException
   {
 	   try{
		      doGet(request, response);
		    }catch (Exception e){
		      miLog.addTraza(e);
		    }
   }

   public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException
   {
      performTask(request, response);
   }
//        if(log == null)
//        {
//            Hierarchy hierarchy = Hierarchy.getDefaultHierarchy();
//            log = hierarchy.getLoggerFor("fop");
//            log.setPriority(Priority.WARN);
//        }
private void fncAbrirFicheroTemporal() throws java.io.IOException
{
         foFileDir = new File(sFoFileDir);
         tmpFoFile = File.createTempFile("m05b", "Fo", foFileDir);
		 tmpFoFileStream = new FileOutputStream(tmpFoFile);

}	

private void fncImprimirFinPagina()throws java.io.IOException
{
     	    sLinea = "	    </fo:table-body>\n";
          	tmpFoFileStream.write(sLinea.getBytes());			            								            		
            sLinea= "       </fo:table>\n";
           	tmpFoFileStream.write(sLinea.getBytes());   
            sLinea = "      </fo:flow>\n";
            tmpFoFileStream.write(sLinea.getBytes());
            sLinea = "   </fo:page-sequence>\n";
            tmpFoFileStream.write(sLinea.getBytes());
	  
}	

private void fncImprimirComienzoPagina()throws java.io.IOException, javax.naming.NamingException
{
	        sLinea = "<fo:page-sequence master-reference=\"general\">\n";
	        tmpFoFileStream.write(sLinea.getBytes());
            //REGION BEFORE
        	sLinea = "		<fo:static-content flow-name=\"xsl-region-before\" >\n";
        	tmpFoFileStream.write(sLinea.getBytes());
		           // --------------    CABECERA DEL LISTADO    --------------
                        //Cabecera 1
		            sLinea = "      <fo:block text-align=\"end\">\n";
		            tmpFoFileStream.write(sLinea.getBytes());
		            sLinea = "      </fo:block>\n";
		            tmpFoFileStream.write(sLinea.getBytes());
                    sLinea = "      <fo:block font-weight=\"bold\" padding-top=\"10pt\">\n " + "Resumen Itvs" + "</fo:block>\n";
			        tmpFoFileStream.write(sLinea.getBytes());
                    sLinea = "      <fo:block font-size=\"8pt\" font-weight=\"bold\" padding-top=\"5pt\">\n <fo:leader leader-pattern=\"space\" leader-length=\"120pt\"/>" + "Desde : " + sFecDesde + "  Hasta : "+sFecHasta+"</fo:block>\n";
			        tmpFoFileStream.write(sLinea.getBytes());
			        sLinea = "      <fo:block font-size=\"10pt\" padding-top=\"10pt\" text-align=\"left\">\n"+sDesDpto +"</fo:block>\n";
					tmpFoFileStream.write(sLinea.getBytes());

        	sLinea = " 		</fo:static-content>\n"; 
        	tmpFoFileStream.write(sLinea.getBytes());

            //PIE DE PAGINA Pie
        	sLinea = "		<fo:static-content flow-name=\"xsl-region-after\">\n";
        	tmpFoFileStream.write(sLinea.getBytes());
                        //PIE DE PAGINA Pie
					sLinea = "      <fo:block >\n";
		            tmpFoFileStream.write(sLinea.getBytes());
		            	sLinea= "       <fo:table>\n";
		            	tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    <fo:table-column column-width=\"80mm\"/>\n";
			            	tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    <fo:table-column column-width=\"80mm\"/>\n";
			            	tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    <fo:table-body font-family=\"Helvetica\" font-size=\"6pt\">\n";
			            	tmpFoFileStream.write(sLinea.getBytes());
			            		sLinea = "	    <fo:table-row>\n";
			            		tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    <fo:table-cell >\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block text-align=\"left\">" + miComun.getDetFechaActual(m05bConstantesInformes.IDIOMA_C)+ "</fo:block>";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    <fo:table-cell >\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
			            			    sLinea = "      <fo:block text-align=\"right\">" ; 
                       		            tmpFoFileStream.write(sLinea.getBytes());
		                                sLinea = "Página <fo:page-number/> \n";
                        	            tmpFoFileStream.write(sLinea.getBytes());
							            sLinea=  "</fo:block>";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
			            		sLinea = "	    </fo:table-row>\n";
			            		tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    </fo:table-body>\n";
			            	tmpFoFileStream.write(sLinea.getBytes());			            								            		
			            sLinea= "       </fo:table>\n";
		            	tmpFoFileStream.write(sLinea.getBytes());
		            sLinea = "      </fo:block>\n";
		            tmpFoFileStream.write(sLinea.getBytes());
        	sLinea = " 		</fo:static-content>\n"; 
        	tmpFoFileStream.write(sLinea.getBytes());
                 //BODY
		         sLinea = "	<fo:flow flow-name=\"xsl-region-body\">\n";
		         tmpFoFileStream.write(sLinea.getBytes());
		         Context ctx =  new InitialContext(System.getProperties());
      	         // --------------    DETALLE DEL LISTADO    --------------
		           		sLinea= "        <fo:table space-after.optimum=\"12pt\">\n";
		            	tmpFoFileStream.write(sLinea.getBytes());
		            		//sLinea = "	    <fo:table-column column-width=\"40mm\"/>\n";
			            	//tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    <fo:table-column column-width=\"40mm\"/>\n";
			            	tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    <fo:table-column column-width=\"80mm\"/>\n";
			            	tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    <fo:table-column column-width=\"40mm\"/>\n";
			            	tmpFoFileStream.write(sLinea.getBytes());
		            		sLinea = "	    <fo:table-body font-family=\"Helvetica\" font-size=\"8pt\">\n";
			            	tmpFoFileStream.write(sLinea.getBytes());
	       	    			    	sLinea = "	    <fo:table-row>\n";
			            		     tmpFoFileStream.write(sLinea.getBytes());
			            			// Fecha Insp.
			            			/*sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block font-weight=\"bold\" text-align=\"center\">\n Fec.Insp."+ "</fo:block>";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());*/
			            			// Matricula
			            			sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block font-weight=\"bold\"  text-align=\"center\">\n Matricula</fo:block>\n";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
		            			   // Resultado
			            			sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block font-weight=\"bold\"  text-align=\"center\">\n Centro</fo:block>\n";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());	
     			                   //Fecha Prox.
			            			sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block font-weight=\"bold\"  text-align=\"center\">\n Fec.Prox.Insp.</fo:block>\n";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());	
			            		sLinea = "	    </fo:table-row>\n";
			            		tmpFoFileStream.write(sLinea.getBytes());
   		                        sLinea = "	    <fo:table-row >\n";
			            		tmpFoFileStream.write(sLinea.getBytes());
}
//Agurtzane Mar12: contador en listados   
private void imprimirTotal(int intCont, boolean bolGeneral)throws java.io.IOException, javax.naming.NamingException
{
	sLinea = "	    <fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		//vacías
		for (int i=0;i<2;i++){
			sLinea = "	    <fo:table-cell>\n<fo:block>\n</fo:block>\n</fo:table-cell>\n";
			tmpFoFileStream.write(sLinea.getBytes());
		}
		//Contador
		sLinea = "	    <fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		if(bolGeneral)
			sLinea = "      <fo:block font-weight=\"bold\" text-align=\"right\"  padding-top=\"26pt\">\n " + "Total General: " + intCont+ "</fo:block>\n";
		else
			sLinea = "      <fo:block font-weight=\"bold\" text-align=\"right\"  padding-top=\"26pt\">\n " + "Total ITVs: " + intCont+ "</fo:block>\n";
       tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
}
//Fin Agurtzane Mar12: contador en listados  
   public void performTask(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws ServletException
   {
	   java.sql.Connection conn=null;
	   PreparedStatement pstmt = null;
	   ResultSet rs = null;
      try
      {  HttpSession session = request.getSession(true);
			m05bConexion miConex = new m05bConexion();
			conn = miConex.getConnection();
		    m05bComun miComun = new m05bComun();
			
      
      	 // Obtención de información de BD
      	 	 	// Vehículo
         String sDpto="";
         String sDptoAnt="";
         sSituacion="";
         sDesDpto="";
         sFecDesde=request.getParameter("FecDesde");
            	if (sFecDesde==null){
					sFecDesde="";}
         sFecHasta=request.getParameter("FecHasta");
            	if (sFecHasta==null){
					sFecHasta="";}
	
      	 String matricula="";
	     String sMatricula = "";
	     String sFecha = "";
	     String sFechaProx = "";
	     String sResultado = "";
	     String sSituacionAnt= "";
	     String sDesDptoAnt= "";
         String sSentencia= "";	
         String sCentro= "";
         String sFechaRep = "";
	     sSentencia=" SELECT " +
						m05bConstantes.COL_27_MATRICULA+","+ 
						m05bConstantes.COL_27_ESTADO+",TO_CHAR("+  
						m05bConstantes.COL_27_FINSPEC+",'dd/mm/yyyy'),TO_CHAR("+  
						m05bConstantes.COL_27_FPRXINSPEC+",'dd/mm/yyyy'),"+  
						m05bConstantes.COL_27_RESULTADO+","+  
						m05bConstantes.COL_34_CODDPTO+","+  
						m05bConstantes.COL_34_DESDPTO+","+
						m05bConstantes.COL_05_DESC+","+
						"TO_CHAR("+ m05bConstantes.COL_27_FREPINSP+",'dd/mm/yyyy')"+
                   " FROM "+
                        m05bConstantes.TAB_ITV+","+
                        m05bConstantes.TAB_VEHICULOS+","+
                        m05bConstantes.TAB_TARJETAS+","+
                        m05bConstantes.TAB_CENTROS+
                   " WHERE " + 
                   m05bConstantes.COL_05_CODIGO+"="+m05bConstantes.COL_31_CENTRO+ " AND " +
                   m05bConstantes.COL_31_MATRICULA+"="+m05bConstantes.COL_34_MATRICULA +" AND "+
                   m05bConstantes.COL_31_TIPO+"='"+m05bConstantes.TAR_GASTO+"' AND "+
                   m05bConstantes.COL_27_MATRICULA+"="+m05bConstantes.COL_34_MATRICULA +"(+) AND "+
                   m05bConstantes.COL_34_MATRICULA+"||"+m05bConstantes.COL_27_FINSPEC + 
                   " in(SELECT "+
                        m05bConstantes.COL_27_MATRICULA+
                   " ||max("+m05bConstantes.COL_27_FINSPEC+
                   " ) FROM "+
                       m05bConstantes.TAB_ITV +
                   " GROUP BY "+m05bConstantes.COL_27_MATRICULA+
                   " ) AND "+m05bConstantes.COL_27_MATRICULA+
                   " ="+m05bConstantes.COL_34_MATRICULA+
                   " AND "+
                   " (((((DECODE("+m05bConstantes.COL_27_FPRXINSPEC+",'',DECODE("+
                   m05bConstantes.COL_27_FREPINSP+",'',TO_DATE('99991231','YYYYMMDD'),"+
                   m05bConstantes.COL_27_FREPINSP+"),"+m05bConstantes.COL_27_FPRXINSPEC+"))"+
                   "-SYSDATE)<0)  AND ("+m05bConstantes.COL_34_SITUACION+" ='A'))) AND ("+
                   m05bConstantes.COL_27_FINSPEC+">= TO_DATE('"+sFecDesde+"','dd/mm/YYYY')) AND ("+
                   m05bConstantes.COL_27_FINSPEC+"<= TO_DATE('"+sFecHasta+"','dd/mm/YYYY'))"+
		           " ORDER BY " + m05bConstantes.COL_34_CODDPTO+","+m05bConstantes.COL_27_FPRXINSPEC+","+m05bConstantes.COL_27_MATRICULA;
        	
         ////System.out.println("m05b - ImpResumenItvServlet" + sSentencia);
         miLog.addTraza("Bego" , "m05b - ImpResumenItvServlet:  " , "sSentencia: " + sSentencia, m05bConstantes.LOG_NIVEL_BAJO);
		     
		 pstmt = conn.prepareStatement(sSentencia);
		 rs = pstmt.executeQuery();

         //String foParam = request.getParameter(FO_REQUEST_PARAM);
	     fncAbrirFicheroTemporal();
         sLinea = "<?xml version=\"1.0\" encoding=\"windows-1252\"?>\n";
         tmpFoFileStream.write(sLinea.getBytes());
         
         sLinea = "<fo:root xmlns:fo=\"http://www.w3.org/1999/XSL/Format\">\n";
         tmpFoFileStream.write(sLinea.getBytes());
		 // LAYOUT DEL LISTADO 
	         sLinea = "<fo:layout-master-set>\n";
	         tmpFoFileStream.write(sLinea.getBytes());
		           sLinea = "	<fo:simple-page-master master-name=\"general\"  page-height=\"29.5cm\" page-width=\"21cm\" margin-top=\"2cm\" margin-bottom=\"2cm\" margin-left=\"2.5cm\" margin-right=\"2.5cm\">\n";
			       tmpFoFileStream.write(sLinea.getBytes());
			         sLinea = "		<fo:region-before extent=\"3cm\"/>\n";
			         tmpFoFileStream.write(sLinea.getBytes());
			         sLinea = "		<fo:region-body  margin-top=\"3.8cm\" margin-bottom=\"1.5cm\" />\n";
			         tmpFoFileStream.write(sLinea.getBytes());
			         sLinea = "		<fo:region-after  extent=\"1cm\"/>\n";
			         tmpFoFileStream.write(sLinea.getBytes());
			         sLinea = "		<fo:region-start extent=\"0cm\"/>\n";
			         tmpFoFileStream.write(sLinea.getBytes());
			         sLinea = "		<fo:region-end extent=\"0cm\"/>\n";
			         tmpFoFileStream.write(sLinea.getBytes());
			         
		            sLinea = "	</fo:simple-page-master>\n";
		          tmpFoFileStream.write(sLinea.getBytes());
	         sLinea = "</fo:layout-master-set>\n";
	         tmpFoFileStream.write(sLinea.getBytes());
			            	int cont=0;
			             	int intCont=0, intContParcial=0;  //Agurtzane Mar12: contador en listados 
			            	while (rs.next()){
			            	//Agurtzane Mar12: contador en listados
			            	intCont++;
			            	intContParcial++;  
//			            		Fin Agurtzane Mar12: contador en listados
		   		    	    sDpto=rs.getString(6)==null ? "":rs.getString(6);
	       	    			sMatricula = rs.getString(1)==null ? "":rs.getString(1);
	       	    			sFecha= rs.getString(3)==null ? "":rs.getString(3);
	       	    			sFechaProx = rs.getString(4)==null ? "":rs.getString(4);
	       	    			sResultado = rs.getString(5)==null ? "":rs.getString(5);
	       	    			sDesDpto = rs.getString(7)==null ? "":rs.getString(7);
	       	    			sSituacion=rs.getString(2)==null ? "":rs.getString(2);
	       	    			sCentro = rs.getString(8)==null ? "":rs.getString(8);
	       	    			sFechaRep = rs.getString(9)==null ? "":rs.getString(9);
         	    			if (((!(sDpto.equals(sDptoAnt)))  )||(cont==40) ||(!(sSituacion.equals(sSituacionAnt)))){
	       	    			   	if ((sDptoAnt!="") || (sSituacionAnt!="")){
	       	    			   	imprimirTotal(intContParcial, false);//Agurtzane Mar12: contador en listados 
			                          fncImprimirFinPagina();
	       	    			   	}	
	       	    			    fncImprimirComienzoPagina();
	       	    			    cont=0;
	       	    			 intContParcial=0;//Agurtzane Mar12: contador en listados 
	       	    		
			            		}else{
	       	    			   	cont=cont+1;   
   		                        sLinea = "	    <fo:table-row >\n";
			            		tmpFoFileStream.write(sLinea.getBytes());}
	       	    			    sDptoAnt=sDpto;
	    	    			    sSituacionAnt=sSituacion;		            		
			            			// Fecha Insp. 
			            			/*sLinea = "	    <fo:table-cell padding-top=\"0.4mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block  text-align=\"center\">\n " + sFecha +"</fo:block>";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());*/
			            			// Matricula
			            			sLinea = "	    <fo:table-cell padding-top=\"0.4mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block  text-align=\"center\">\n "+ sMatricula +"</fo:block>\n";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
			            			// Centro
			            			sLinea = "	    <fo:table-cell padding-top=\"0.4mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block  text-align=\"center\">\n"+sCentro+"</fo:block>\n";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
            			            // Fecha Prox.
			            			sLinea = "	    <fo:table-cell padding-top=\"0.4mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
			            			tmpFoFileStream.write(sLinea.getBytes());
							            sLinea = "      <fo:block  text-align=\"center\">\n"+((sFechaProx==null||sFechaProx.equals(""))?sFechaRep:sFechaProx)+"</fo:block>\n";
							            tmpFoFileStream.write(sLinea.getBytes());
			            			sLinea = "	    </fo:table-cell>\n";
			            			tmpFoFileStream.write(sLinea.getBytes());			            			
			 			            		sLinea = "	    </fo:table-row>\n";
			            		tmpFoFileStream.write(sLinea.getBytes());
			            	}
//			            	Agurtzane Mar12: contador en listados
			            	intContParcial++;
			            	imprimirTotal(intContParcial, false);
			            	imprimirTotal(intCont, true);
			            	//Fin Agurtzane Mar12: contador en listados
			        fncImprimirFinPagina();
			        rs.close();	
			        
         sLinea = "</fo:root>\n";
         tmpFoFileStream.write(sLinea.getBytes());
         
         tmpFoFileStream.close();
         //renderFO(new InputSource(file), response);
         generarPDFdesdeFO(sFoFileDir + tmpFoFile.getName(),sFoFileDir,response);         

         //tmpFoFile.delete();

         //response.flushBuffer();


      } catch (Exception ex)   {
      	try {
			response.sendRedirect("m05bError.jsp");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			miLog.addTraza(e);
		}
      } finally {
	   	    try {
				if (rs != null)
					rs.close();
				if (pstmt != null)
					pstmt.close();
				if (conn != null)
					conn.close();
			} catch (SQLException e2) {
				try {
					response.sendRedirect("m05bError.jsp");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					miLog.addTraza(e);
				}
	  		}
	   }
    }

    /**
     * renders an FO inputsource into a PDF file which is rendered
     * directly to the response object's OutputStream
     */
    public void renderFO(InputSource foFile, HttpServletResponse response) throws ServletException
    {
        try
        {
            ByteArrayOutputStream out = new ByteArrayOutputStream();

	    	response.reset();
            OutputStream oOut=response.getOutputStream();
            BufferedOutputStream bOut=new BufferedOutputStream(oOut);
            Driver driver = new Driver(foFile, out);
            driver.setRenderer(Driver.RENDER_PDF);
            driver.run();

            response.setContentLength(out.size());
	    response.setContentType("application/pdf");


            bOut.write(out.toByteArray());
	    out.close();
	    bOut.flush();
            bOut.close();
//	    response.flushBuffer();
        }
        catch (Exception ex)
        {
            throw new ServletException(ex);
        }
    }
public void generarPDFdesdeFO(String ficheroFO, String rutaPDF, HttpServletResponse response) throws FOPException {
        try {

            Driver driver = new Driver();

            driver.setRenderer(Driver.RENDER_PDF);

            //Si no existe el directrio lo crea
            File f = new File(rutaPDF);

            if (!f.exists()) {

                f.mkdir();


            }
            //Cargar los datos del .FO
            FileInputStream file = new FileInputStream(ficheroFO);

            BufferedInputStream bfile=new BufferedInputStream(file);

            driver.setInputSource(new InputSource(bfile));


            //Crear un temporal que va a ser el .pdf
            String sPdfFileDir = rutaPDF;
            File   pdfFileDir = new File(sPdfFileDir);
            File   tmpPdfFile = File.createTempFile("m05b", ".pdf", pdfFileDir);


            FileOutputStream fileout = new FileOutputStream(tmpPdfFile);

            BufferedOutputStream bfileout=new BufferedOutputStream(fileout);

            driver.setOutputStream(bfileout);

            driver.run();


 

            bfile.close();

            bfileout.close();
            //Longitus del Fichero PDF.
            Long longitud = new Long(tmpPdfFile.length());            
            String sLongitud=""+ longitud;
            int iLongitud=Integer.parseInt(sLongitud);

            response.setContentLength((int)iLongitud);
	        response.setContentType("application/pdf");
	        
            byte[] fileBytes = new byte[longitud.intValue()];
            FileInputStream fisficheroPdf = new FileInputStream(tmpPdfFile);
            fisficheroPdf.read(fileBytes);
            ServletOutputStream os = response.getOutputStream();
            ((OutputStream)os).write(fileBytes);
            ((OutputStream)os).flush();
            ((OutputStream)os).close();

            // BORRAR EL FICHERO FO

            File fichero = new File(ficheroFO);
            

            boolean borrado = fichero.delete();
            boolean borrado2 = tmpPdfFile.delete();

        } catch (Exception e) {

            ////System.out.println("EXCEPCION !!! : Error pasando de FO a PDF: " + e);

        }


    }    
}